Table of contents
-----------------

* Introduction
* Features
* Requirements
* Notes


Introduction
------------

The **Schema.org Blueprints Demo Next.js module** provides a demo Schema.org 
Blueprints using Next.js for Drupal.

This modules

- Configures Next.js site, user, and roles.
- Experiments with exposing Drupal's entity and field data 
  (i.e. labels and descriptions) to a Next.js application. 
- Provides a PostMan script to review Next.js authentication and JSON:API.  
  @see postman/schemadotorg\_demo\_next.postman_collection.json


Features
--------

General

- Removes all permissions from anonymous users.
- Set the front page to the moderation dashboard.

User login

- Redirects anonymous users to /user/login.
- Displays a welcome message via JavaScript.

Next.js

- Imports 'schemadotorg_demo_next' user role configuration.
- Imports 'Next.js site' configuration.
- Import JSON:API resource configuration for exposing entity and field 
  data to Next.js applications.  
- Creates 'next' user account used for basic authentication preview.
- Creates 'next' consumer with uuid, client id, and secret with image styles.
- Sets Oauth public and private keys. (i.e. /Users/USER/Sites/drupal_next/keys)
- Adds a 'schemadotorg_demo_next_site' Next.js site.
- Allow Next.js role to view entity and field data. 


Requirements
------------

**[Schema.org Blueprints Next.js demo](https://www.drupal.org/sandbox/jrockowitz/3305940)**  
Provides a starting point for building a Next.js front-end for a Drupal site
created using the Schema.org Blueprints module.


Notes
-----

### Entity and field label and description access

The Drupal Next.js module and starter kit provides demonstration on how to build
pages via Next.js/React without any suggestion on how to leverage entity 
and field configuration labels and descriptions with translation in Drupal.

The included JSON:API and Postman script shows how to a subrequest to access
entity and field configuration.

@see [Incredible Decoupled Performance with Subrequests](https://www.lullabot.com/articles/incredible-decoupled-performance-with-subrequests)

### Oauth Credentials

The below credentials give Next.js access to view content, entity,
and field data.

**These credential should never be used on production website**.

    Client ID: 00000000-0000-0000-0000-000000000000
    Client Secret: secret
    Username: next
    Password: next
